﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebAPITest.Data.Models
{
    public class BookContextSeeder
    {
        BookStoreContext context;
        public BookContextSeeder(BookStoreContext _bookStoreContext)
        {
            context = _bookStoreContext;
        }
        public void Seed()
        {
            if(!context.Books.Any())
            {
                var commonauthor = new Author()
                {
                    FirstName = "Martin",
                    LastName = "Fowler",
                    NickName = "M Fowler"
                };
                List<Book> listofBooks = new List<Book>()
                {
                    new Book()
                    {
                        Title = "Learning ASP.NET Web API",
                        Genre = "Technology",
                        ISBN = "11111",
                        PublishedOn = DateTime.UtcNow.AddYears(-2),
                        Author = new Author()
                        {
                           FirstName = "Brij",
                           MiddleName = "Bhushan",
                           LastName = "Mishra",
                           NickName = "Brij"
                        }
                    },
                    new Book()
                    {
                        Title = "Microservices in Action",
                        Genre = "Technology",
                        ISBN = "55555",
                        PublishedOn = DateTime.UtcNow.AddYears(-1),
                        Author = commonauthor

                    },
                    new Book()
                    {
                        Title = "Influencer",
                        Genre = "Motivational",
                        ISBN = "22222",
                        PublishedOn = DateTime.UtcNow.AddYears(-5),
                        Author = new Author()
                        {
                           FirstName = "Patterson",
                           LastName = "Grenny",
                           NickName = "McMillan"
                        }
                    },
                    new Book()
                    {
                        Title = "Patterns of Enterprise Applications Architecture",
                        Genre = "Technology",
                        ISBN = "33333",
                        PublishedOn = DateTime.UtcNow.AddYears(-1),
                        Author = commonauthor
                    }

                };

                context.Books.AddRange(listofBooks);
                context.Authors.Add(listofBooks[0].Author);
                context.Authors.Add(listofBooks[1].Author);
                context.Authors.Add(listofBooks[2].Author);
               // context.Authors.Add(listofBooks[3].Author);

                context.SaveChanges();
            }
        }
    }
}
