﻿using Microsoft.Data.Entity;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebAPITest.Data.Models
{
    public class BookStoreRepository : IBookStoreRepository
    {
        private BookStoreContext context;

        public BookStoreRepository(BookStoreContext _bookStoreContext)
        {
            context = _bookStoreContext;
        }

        public Author FindAutor(int _id, bool includeBooks = false)
        {
            if (includeBooks)
            {
                return context.Authors.Include(a => a.Books).FirstOrDefault<Author>(a => a.Id == _id);
            }
            return context.Authors.FirstOrDefault<Author>(a => a.Id == _id);
        }

        public Book FindBook(int _id, bool includeAuthor = false)
        {
            if (includeAuthor)
            {
                return context.Books.Include(b => b.Author).FirstOrDefault<Book>(b => b.Id == _id);
            }
            return context.Books.FirstOrDefault<Book>(b => b.Id == _id);
        }

        public void AddBook(Book _newBook)
        {
            throw new NotImplementedException();
        }

        public bool DeleteBook(Book _booktoDelete)
        {
            throw new NotImplementedException();
        }

        public IList<Author> GetAllAuthors()
        {
            return context.Authors.ToList();
        }

        public IList<Author> GetAllAuthorswithBooks()
        {
            return context.Authors.Include(a => a.Books).ToList();
        }

        public IList<Book> GetAllBooks()
        {
            return context.Books.ToList();
        }

        public IList<Book> GetAllBookswithAuthor()
        {
            return context.Books.Include(b => b.Author).ToList();
        }

        public bool UpdateBook(Book _booktoUpdate)
        {
            throw new NotImplementedException();
        }
    }
}
