﻿using Microsoft.AspNet.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using WebAPITest.Data.Models;

namespace WebAPIDemo_1.Controllers
{
    [Route("api/[controller]")]
    public class BooksController : Controller
    {
        private IBookStoreRepository repository;

        public BooksController(IBookStoreRepository _repository)
        {
            this.repository = _repository;
        }

        [HttpGet]
        public IEnumerable<Book> Get()
        {
            return this.repository.GetAllBooks();
        }

        [HttpGet("{id:int}/{includeAuthor:bool?}")]
        public Book Get(int Id, bool includeAuthor = false)
        {
            return this.repository.FindBook(Id, includeAuthor);
        }

        [HttpGet("{id:int}/author")]
        public Author Get(int id)
        {
            return this.repository.FindBook(id, true).Author;
        }

        [HttpPost]
        public IActionResult Post([FromBody]Book newBook)
        {
            if(newBook == null)
            {
                return HttpBadRequest("Data is not received in proper format");
            }

            var addedBook = this.repository.AddBook(newBook);

            if (addedBook == null)
            {
                return HttpBadRequest("Error while adding a book");
            }
            

            return Created(Request.Path + "/" + addedBook.Id, addedBook);

        }

        //public IEnumerable<string> Get()
        //{
        //    return new List<string>() { "Brij", "John" };
        //}
    }
}
