﻿using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using WebAPIDemo_1.Models;
using WebAPITest.Data.Models;


namespace WebAPIDemo_1.Controllers
{
    public class AccountController : Controller
    {
        private SignInManager<ApplicationUser> _signInManager;

        public AccountController(SignInManager<ApplicationUser> signInManager)
        {
            _signInManager = signInManager;
        }


        public IActionResult Login()
        {
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> Login(LoginVM login)
        {
            var signInStatus = await _signInManager.PasswordSignInAsync(login.UserName, login.Password, false, false);
            if (signInStatus == SignInResult.Success)
            {
                return Content("Successfully logged in");
            }

            return View();
        }


        public IActionResult SignOut()
        {
            _signInManager.SignOutAsync(); // SignOut();
            return Redirect("/home");
        }
    }
}
