﻿using Microsoft.AspNet.Mvc.Filters;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WebAPIDemo_1.Filters
{
    public class RequireHttpsAttribute : AuthorizationFilterAttribute
    {
        public override void OnAuthorization(AuthorizationContext context)
        {
            if (context.HttpContext.Request.Scheme.ToLowerInvariant() != "https")
            {
                context.HttpContext.Response.StatusCode = 403;
                context.HttpContext.Response.Body = new MemoryStream(Encoding.UTF8.GetBytes("Https required"));
            }
        }
    }
}
